/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TIPOCIA                                                  */
/* Tabela : TIPOCIA                                                           */
/*                                                                            */
/* Criao:                                                                   */
/* 08/10/2003 Bruno Leonardo                                                  */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_TIPOCIA
BEFORE INSERT OR UPDATE OR DELETE
ON TIPOCIA FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUTCIA := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDTPCIA,0) <> NVL(:NEW.CDTPCIA,0)) OR
         (NVL(:OLD.DSTPCIA,0) <> NVL(:NEW.DSTPCIA,0)) THEN
         :NEW.DTULTATUTCIA := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('TIPOCIA', '', 'CDTPCIA='||:OLD.CDTPCIA||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE TIPOCIA MODIFY DTULTATUTCIA DEFAULT SYSDATE
/
