/* Tabela COMPCARD: Pratos do Cardpio */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela COMPCARD */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela COMPCARD,
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_PLA_COMPCARD
AFTER DELETE OR INSERT OR UPDATE
ON COMPCARD FOR EACH ROW
DECLARE
  V_USUARIO    VARCHAR2(40);
  V_TIPO       VARCHAR2(1);
  V_ITPESQ     VARCHAR2(40);
  V_DESC       VARCHAR2(500);
  V_DTOPER     DATE;
  V_DSIP       VARCHAR2(50);
  V_DSUSUARIO  VARCHAR2(50);
  V_DSRDM      VARCHAR2(50);
  V_DSMETODO   VARCHAR2(250);
  V_DSOPERADOR VARCHAR2(12);
BEGIN
   V_TIPO      := '0';
   V_DESC      := '';
   WEBTUNNING(V_DSIP,
              V_DSUSUARIO,
              V_DSRDM,
              V_DSMETODO,
              V_DSOPERADOR);
   IF DELETING THEN
      V_DESC := V_DESC || 'Fili=' || :OLD.CDFILIAL;
      V_DESC := V_DESC || ' Card=' || :OLD.NRCARDAPIO;
      V_DESC := V_DESC || ' TipoPrat=' || :OLD.CDTIPOPRAT;
      V_DESC := V_DESC || ' Prato=' || :OLD.CDPRATO;
      V_DESC := V_DESC || ' Arv=' || :OLD.CDFILAUXPRAT;
      IF (NVL(:OLD.QTCOMEFETPRA, -1) <> -1) THEN
         V_DESC := V_DESC || ' EfetPrat=' || :OLD.QTCOMEFETPRA;
      END IF;
      V_DESC := V_DESC || ' Sequ=' || :OLD.NRSEQPRATCAR;
      V_DESC := V_DESC || ' Percentual Cons=' || :OLD.VRPECONSCARD;
      IF (NVL(:OLD.QTSOBRLIMPPR, -1) <> -1) THEN
         V_DESC := V_DESC || ' Sobra Limpa=' || :OLD.QTSOBRLIMPPR;
      END IF;
      IF (NVL(:OLD.QTPRODUZPRAT, -1) <> -1) THEN
         V_DESC := V_DESC || ' Qtde Vend=' || :OLD.QTPRODUZPRAT;
      END IF;
      IF (NVL(:OLD.NRORDPRATCAR, -1) <> -1) THEN
         V_DESC := V_DESC || ' Ordem Visual=' || :OLD.NRORDPRATCAR;
      END IF;
      V_DESC := V_DESC || ' Rdm='      || V_DSRDM;
      V_DESC := V_DESC || ' Mtodo='   || V_DSMETODO;
      V_DESC := V_DESC || ' Ip='       || V_DSIP;
      V_DESC := V_DESC || ' Usurio='  || V_DSUSUARIO;
      V_DESC := V_DESC || ' Operador=' || V_DSOPERADOR;
      V_TIPO := '3';
      V_ITPESQ := :OLD.CDFILIAL||:OLD.NRCARDAPIO||:OLD.CDPRATO||:OLD.NRSEQPRATCAR;
   ELSE
      IF UPDATING THEN
         IF (:OLD.CDFILIAL     <> :NEW.CDFILIAL    ) OR
            (:OLD.NRCARDAPIO   <> :NEW.NRCARDAPIO  ) OR
            (:OLD.NRSEQPRATCAR <> :NEW.NRSEQPRATCAR) OR
            (:OLD.CDFILAUXPRAT <> :NEW.CDFILAUXPRAT) OR
            (:OLD.CDPRATO      <> :NEW.CDPRATO     ) OR
            (:OLD.VRPECONSCARD <> :NEW.VRPECONSCARD) OR
            (:OLD.CDTIPOPRAT   <> :NEW.CDTIPOPRAT  ) OR
            (NVL(:OLD.QTSOBRLIMPPR, -1) <> NVL(:NEW.QTSOBRLIMPPR, -1)) OR
            (NVL(:OLD.QTCOMEFETPRA, -1) <> NVL(:NEW.QTCOMEFETPRA, -1)) OR
            (NVL(:OLD.QTPRODUZPRAT, -1) <> NVL(:NEW.QTPRODUZPRAT, -1)) OR
            (NVL(:OLD.NRORDPRATCAR, -1) <> NVL(:NEW.NRORDPRATCAR, -1)) THEN
            V_TIPO   := '2';
            V_ITPESQ := :OLD.CDFILIAL||:OLD.NRCARDAPIO||:OLD.CDPRATO||:OLD.NRSEQPRATCAR;
         END IF;
      ELSE
         V_TIPO   := '1';
         V_ITPESQ := :NEW.CDFILIAL||:NEW.NRCARDAPIO||:NEW.CDPRATO||:NEW.NRSEQPRATCAR;
      END IF;
      IF UPDATING THEN
         IF (:OLD.CDFILIAL <> :NEW.CDFILIAL) THEN
            V_DESC := V_DESC || 'Fili=' || :OLD.CDFILIAL || '|' || :NEW.CDFILIAL;
         ELSE
            V_DESC := V_DESC || 'Fili=' || :OLD.CDFILIAL;
         END IF;
      ELSE
         V_DESC := V_DESC || 'Fili=' || :NEW.CDFILIAL;
      END IF;
      IF UPDATING THEN
         IF (:OLD.NRCARDAPIO <> :NEW.NRCARDAPIO) THEN
            V_DESC := V_DESC || ' Card=' || :OLD.NRCARDAPIO || '|' || :NEW.NRCARDAPIO;
         ELSE
            V_DESC := V_DESC || ' Card=' || :OLD.NRCARDAPIO;
         END IF;
      ELSE
         V_DESC := V_DESC || ' Card=' || :NEW.NRCARDAPIO;
      END IF;
      IF UPDATING THEN
         IF (:OLD.CDTIPOPRAT <> :NEW.CDTIPOPRAT) THEN
            V_DESC := V_DESC || ' TipoPrat=' || :OLD.CDTIPOPRAT || '|' || :NEW.CDTIPOPRAT;
         ELSE
            V_DESC := V_DESC || ' TipoPrat=' || :OLD.CDTIPOPRAT;
         END IF;
      ELSE
         V_DESC := V_DESC || ' TipoPrat=' || :NEW.CDTIPOPRAT;
      END IF;
      IF UPDATING THEN
         IF (:OLD.CDPRATO <> :NEW.CDPRATO) THEN
            V_DESC := V_DESC || ' Prato=' || :OLD.CDPRATO || '|' || :NEW.CDPRATO;
         ELSE
            V_DESC := V_DESC || ' Prato=' || :OLD.CDPRATO;
         END IF;
      ELSE
         V_DESC := V_DESC || ' Prato=' || :NEW.CDPRATO;
      END IF;
      IF UPDATING THEN
         IF (:OLD.CDFILAUXPRAT <> :NEW.CDFILAUXPRAT) THEN
            V_DESC := V_DESC || ' Arv=' || :OLD.CDFILAUXPRAT || '|' || :NEW.CDFILAUXPRAT;
         END IF;
      ELSE
         V_DESC := V_DESC || ' Arv=' || :NEW.CDFILAUXPRAT;
      END IF;
      IF (NVL(:NEW.QTCOMEFETPRA, -1) <> -1) OR (UPDATING AND (NVL(:NEW.QTCOMEFETPRA, -1) = -1)) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.QTCOMEFETPRA, -1) <> NVL(:NEW.QTCOMEFETPRA, -1)) THEN
               V_DESC := V_DESC || ' EfetPrat=' || :OLD.QTCOMEFETPRA || '|' || :NEW.QTCOMEFETPRA;
            END IF;
         ELSE
            V_DESC := V_DESC || ' EfetPrat=' || :NEW.QTCOMEFETPRA;
         END IF;
      END IF;
      IF UPDATING THEN
         IF (:OLD.NRSEQPRATCAR <> :NEW.NRSEQPRATCAR) THEN
            V_DESC := V_DESC || ' Sequ=' || :OLD.NRSEQPRATCAR || '|' || :NEW.NRSEQPRATCAR;
         END IF;
      ELSE
         V_DESC := V_DESC || ' Sequ=' || :NEW.NRSEQPRATCAR;
      END IF;
      IF UPDATING THEN
         IF (:OLD.VRPECONSCARD <> :NEW.VRPECONSCARD) THEN
            V_DESC := V_DESC || ' Percentual Cons=' || :OLD.VRPECONSCARD || '|' || :NEW.VRPECONSCARD;
         END IF;
      ELSE
         V_DESC := V_DESC || ' Percentual Cons=' || :NEW.VRPECONSCARD;
      END IF;
      IF (NVL(:NEW.QTSOBRLIMPPR, -1) <> -1) OR (UPDATING AND (NVL(:NEW.QTSOBRLIMPPR, -1) = -1)) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.QTSOBRLIMPPR, -1) <> NVL(:NEW.QTSOBRLIMPPR, -1)) THEN
               V_DESC := V_DESC || ' Sobra Limpa=' || :OLD.QTSOBRLIMPPR || '|' || :NEW.QTSOBRLIMPPR;
            END IF;
         ELSE
            V_DESC := V_DESC || ' Sobra Limpa=' || :NEW.QTSOBRLIMPPR;
         END IF;
      END IF;
      IF (NVL(:NEW.QTPRODUZPRAT, -1) <> -1) OR (UPDATING AND (NVL(:NEW.QTPRODUZPRAT, -1) = -1)) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.QTPRODUZPRAT, -1) <> NVL(:NEW.QTPRODUZPRAT, -1)) THEN
               V_DESC := V_DESC || ' Qtde Vend=' || :OLD.QTPRODUZPRAT || '|' || :NEW.QTPRODUZPRAT;
            END IF;
         ELSE
            V_DESC := V_DESC || ' Qtde Vend=' || :NEW.QTPRODUZPRAT;
         END IF;
      END IF;
      IF (NVL(:NEW.NRORDPRATCAR, -1) <> -1) OR (UPDATING AND (NVL(:NEW.NRORDPRATCAR, -1) = -1)) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.NRORDPRATCAR, -1) <> NVL(:NEW.NRORDPRATCAR, -1)) THEN
               V_DESC := V_DESC || ' Ordem Visual=' || :OLD.NRORDPRATCAR || '|' || :NEW.NRORDPRATCAR;
            END IF;
         ELSE
            V_DESC := V_DESC || ' Ordem Visual=' || :NEW.NRORDPRATCAR;
         END IF;
      END IF;
      V_DESC := V_DESC || ' Rdm='      || V_DSRDM;
      V_DESC := V_DESC || ' Mtodo='   || V_DSMETODO;
      V_DESC := V_DESC || ' Ip='       || V_DSIP;
      V_DESC := V_DESC || ' Usurio='  || V_DSUSUARIO;
      V_DESC := V_DESC || ' Operador=' || V_DSOPERADOR;
   END IF;
   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER, IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
            VALUES
               ('COMPCARD', V_DTOPER, V_USUARIO, V_TIPO, V_ITPESQ, SUBSTR(V_DESC, 1, 300),
                V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_DSOPERADOR, NVL(:NEW.CDFILIAL, :OLD.CDFILIAL));
         END IF;
      END IF;
   END IF;
END;
/

